#ifndef GUARD_TDIMPFIT
#define GUARD_TDIMPFIT
#include "TH1.h"
#include "TDCanvMan.hh"
#include <iostream>
#include "TF1.h"
#include <string>
#include "math.h"
#include "TPad.h"

#define PI 3.14159265
#define _alpha0 0.7052
class TDImpFit;

class TDImpFit
{
  public:
    //constructors
    TDImpFit(TH1F * HistToFit);
    TDImpFit(TH1F * HistToFit, 
             double charmfraction,
	     double lambda1,
	     double lambda2,
	     double sigmaD,
	     double epsilon1);//,
	     //double epsilon2);

    ~TDImpFit();
    
    //other functions
    void     DoInitialFit();
    void     DoFinalFit();
    static Double_t FD(Double_t *x, Double_t *par);
    static Double_t ImpFunc(Double_t *x, Double_t *par);
    static TDImpFit* _thisTDImpFit;
    //static void GetClassPointer();
    double   Convolute(double lambda1, double lambda2, double epsilon1, double d0);
    double   FB(double d0, double lambda1, double lambda2, double epsilon1);
    double   FD2(double d0);
    void     PrintParameters();
    void     InitiateVariables(double charmfraction,
		                 double lambda1,
			         double lambda2,
			         double sigmaD,
				 double epsilon1);//,
				 //double epsilon2);
    
    //accessors
    void SetHistToFit        (TH1F * HistToFit)      {_HistToFit=HistToFit        ;}
    void SetTDCanvMan        (TDCanvMan * CanvMan)   {_CanvMan=CanvMan            ;}
    void Setcharmfraction    (double charmfraction)  {_charmfraction=charmfraction;}
    void SetlambdaD          (double lambdaD)        {_lambdaD=lambdaD            ;}
    void Setlambda1          (double lambda1)        {_lambda1=lambda1            ;}
    void Setlambda2          (double lambda2)        {_lambda2=lambda2            ;}
    void SetsigmaD           (double sigmaD)         {_sigmaD=sigmaD              ;}
    void Setepsilon1         (double epsilon1)       {_epsilon1=epsilon1          ;}
    void Setbottomfraction   (double bottomfraction) {_bottomfraction=bottomfraction;}
    TH1F * GetHistToFit      ()                      {return _HistToFit           ;}
    TDCanvMan * GetTDCanvMan ()                      {return _CanvMan             ;}
    double Getcharmfraction  ()                      {return _charmfraction       ;}
    double GetlambdaD        ()                      {return _lambdaD             ;}
    double Getlambda1        ()                      {return _lambda1             ;} 
    double Getlambda2        ()                      {return _lambda2             ;}
    double GetsigmaD         ()                      {return _sigmaD              ;}
    double Getepsilon1       ()                      {return _epsilon1            ;} 
    double Getbottomfraction ()                      {return _bottomfraction      ;}
    TF1 *  GetFDFunc         ()                      {return _FDFunc              ;}
    int    GetBinnumber      ()                      {return _binnumber           ;}
    
    
  protected:
    TH1F *          _HistToFit;
    TDCanvMan *     _CanvMan;
    TF1 *           _FDFunc;
    TF1 *           _ImpFunc;
    double          _charmfraction;
    double          _lambdaD;
    double          _lambda1;
    double          _lambda2;
    double          _sigmaD;
    double          _epsilon1;
    //double          _epsilon2;
    int             _binnumber;
    double          _HighEdge;
    double          _LowEdge;
    double          _bottomfraction;
  public:
    //static TDImpFit* _this;
    ClassDef(TDImpFit,1)
};
#endif
